/****************************************************************************
    FILE: COMMON.H

    PURPOSE: contains function declarations, #defines,
             and constants common to all programs.

    History:
                January, 1992       Alok Sinha      Created
****************************************************************************/


/* Common constants  */

#define MAXFILENAME 256          /* maximum length of file pathname      */
#define MAXPATH     256          /* maximum path length                  */
#define NO_ERROR    0
#define NETBIOS_NAME_LENGTH 16	 /* Maximum NetBIOS name		 */
#define ERROR_OUT_OF_MEMORY 102  /* out of memory error */
#define SERVER_NAME_END     'A'
#define MAX_LINE_SIZE       80   /* File detail line shown in list box */

/*
 *  User defined messages
 *
 */

#define NO_MESSAGE	     (WM_USER + 1)


#define BW_CALL_BACK	     (WM_USER + 100)
#define BW_LISTEN_BACK	     (WM_USER + 101)
#define BW_C_RECEIVE_BACK    (WM_USER + 102)
#define BW_S_RECEIVE_BACK    (WM_USER + 103)
#define BW_C_SEND_BACK	     (WM_USER + 104)
#define BW_S_SEND_BACK	     (WM_USER + 105)

#define CLIENT_CONNECTED     (WM_USER + 201)

#define LIST_PROCESSING      (WM_USER + 202)
/*
 * Common functions
 */

BOOL _loadds MessageLoop (MSG FAR *);
VOID HourGlass           (BOOL );
VOID InitServer          (HWND );
VOID DeleteServer        (VOID );
VOID Server              (HWND );
VOID ReceiveCompleted    (HWND, PNCB );
VOID ListenCompleted     (HWND, PNCB );
